angular.module('controllers', [])

.controller('AppCtrl', function($scope, $rootScope, $cordovaNetwork, $ionicHistory, $state, $ionicPopover, $timeout, $ionicSideMenuDelegate, dataService) {
    document.addEventListener("deviceready", function () {

    var type = $cordovaNetwork.getNetwork()

    var isOnline = $cordovaNetwork.isOnline()

    var isOffline = $cordovaNetwork.isOffline()


    // listen for Online event
    $rootScope.$on('networkOffline', function(event, networkState){
      var onlineState = networkState;
    })

    // listen for Offline event
    $rootScope.$on('networkOffline', function(event, networkState){
      var offlineState = networkState;
    })

  }, false);
  // With the new view caching in Ionic, Controllers are only called
  // when they are recreated or on app start, instead of every page change.
  // To listen for when this page is active (for example, to refresh data),
  // listen for the $ionicView.enter event:
  //$scope.$on('$ionicView.enter', function(e) {
  //});

  // Form data for the login modal
  //$scope.loginData = {};
   
  // Create the login modal that we will use later
  //$ionicModal.fromTemplateUrl('templates/login.html', {
  //  scope: $scope
  //}).then(function(modal) {
  //  $scope.modal = modal;
  //});
  
  /*$scope.showConfirm = function() {
   var confirmPopup = $ionicPopup.confirm({
     title: 'Are you sure?',
     template: 'Are you sure you want to delete?'
   });
   confirmPopup.then(function(res) {
     if(res) {
       console.log('You are sure');
     } else {
       console.log('You are not sure');
     }
   });
 };*/

  // Triggered in the login modal to close it
  //$scope.closeLogin = function() {
  //  $scope.modal.hide();
  //};

  // Open the login modal
  //$scope.login = function() {
  //  $scope.modal.show();
  //};

  // Perform the login action when the user submits the login form
  //$scope.doLogin = function() {
  //  console.log('Doing login', $scope.loginData);

    // Simulate a login delay. Remove this and replace with your login
    // code if using a login system
    //$timeout(function() {
    //  $scope.closeLogin();
    //}, 1000);
  //};
  
    treedata = function() {
      var _lang     = document.getElementById('lang').value;
      dataService.menu(_lang).success(function(data) {
            $scope.treedata = data;
        }).finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
        });
    };
  
    $ionicPopover.fromTemplateUrl('templates/popover.html', {
        scope: $scope
    }).then(function(popover){
        $scope.popover = popover;
    });
    $scope.openPopover = function($event) {
        $scope.popover.show($event);
    }; 
    
    $scope.language = function(){
      dataService.bahasa().success(function(data) {
          $scope.language = data.lang;
          $scope.data = {
            langSession: data.lang_session
        };
      }).finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
      });
   };
   
    $scope.language();
    $scope.languageChange = function(item){
        document.getElementById('lang').value = item.value;
        
        $ionicHistory.nextViewOptions({
            historyRoot: true,
            disableBack: true,
            disableAnimation: true
        });
        $state.go('app.home',{}, {reload: true});
        $scope.popover.hide();
        treedata();
    };
    var navIcons  = document.getElementsByClassName('ion-navicon');
    for (var i = 0; i < navIcons.length; i++) {
        navIcons.addEventListener('click', function () {
            this.classList.toggle('active');
        });
    }
    treedata();
    
})

.controller('HomeCtrl', function($scope, $ionicHistory, dataService, $ionicSlideBoxDelegate, $timeout, $location) {
    
    var _lang     = document.getElementById('lang').value;
    $ionicHistory.clearHistory();
    $scope.items = [];
    homes = function() {
        document.getElementById('idExists').value   = '';
        document.getElementById('pageExists').value = 0;
        dataService.home(_lang).success(function(data) {
            $timeout(function() {
                $ionicSlideBoxDelegate.slide(0);
                $ionicSlideBoxDelegate.update();
                $scope.$apply();
            });
            $scope.items = data;
            $timeout(function() {
                document.getElementById('idExists').value   = data.idExists;
                document.getElementById('pageExists').value = data.pageExists;
            },2000);
        }).finally(function(){
            $scope.$broadcast('scroll.refreshComplate');
        });
    };
    homes();
    $scope.doRefresh = function() {
        homes();
        $scope.$broadcast('scroll.refreshComplete');
    };
    $scope.moreDataCanBeLoaded = function(){
        
        pageExists = document.getElementById('pageExists').value;
        var total = $scope.items.allPage;
        var totalExists = $scope.items.pageExists;
        if(pageExists == 0){
            return false;
        }else{
            if(total <= totalExists){
                return false;
            }else{
                return true;
            }
        }
    };
    $scope.loadMoreData = function(){
        var PageExists  = document.getElementById('pageExists').value;
        var IdExists    = document.getElementById('idExists').value;
        dataService.homeMore(_lang, PageExists, IdExists).success(function(data) {
            if(data.success == true){
                for(i=0;i<data.content.length;i++){
                    var _id         = data.content[i].id;
                    var _prefix     = data.content[i].prefix;
                    var _title      = data.content[i].title;
                    var _thumb      = data.content[i].thumb;
                    var _preview    = data.content[i].preview;
                    var _tanggalv1  = data.content[i].tanggal;
                    var _tanggalv2  = data.content[i].tanggalv2;
                    var _counter    = data.content[i].counter;
                    
                    $scope.items.home.push({
                        id: _id,
                        prefix: _prefix,
                        title: _title,
                        tanggal: _tanggalv1,
                        tanggalv2: _tanggalv2,
                        counter: _counter,
                        thumb: _thumb,
                        preview: _preview
                    });
                    document.getElementById('pageExists').value = data.pageExists;
                }
			          $scope.$broadcast('scroll.infiniteScrollComplete');
            }
        });
    };
    
    $scope.$on('$viewContentLoaded', function(){
        //view loaded do some stuff.
        $location.replace(); //clear last history route
    });
})

.controller('PostCtrl', function($scope, $ionicHistory, $stateParams, dataService, $ionicSlideBoxDelegate, $timeout, $location){
    var _lang     = document.getElementById('lang').value;
    $ionicHistory.clearHistory();
    $scope.items = [];
    posts = function() {
        document.getElementById('idExists').value   = '';
        document.getElementById('pageExists').value = 0;
        dataService.post(_lang, $stateParams.postId).success(function(data) {
            $scope.posts = data;
            $scope.kategori = data.kategori;
            $timeout(function() {
                $ionicSlideBoxDelegate.slide(0);
                $ionicSlideBoxDelegate.update();
                $scope.$apply();
            });
            $scope.items = data;
            $timeout(function() {
                document.getElementById('idExists').value   = data.idExists;
                document.getElementById('pageExists').value = data.pageExists;
            },2000);
        }).finally(function(){
            $scope.$broadcast('scroll.refreshComplate');
        });
    };
    $scope.doRefresh = function() {
        posts();
        $scope.$broadcast('scroll.refreshComplete');
    };
    $scope.moreDataCanBeLoaded = function(){
        
        pageExists = document.getElementById('pageExists').value;
        var total = $scope.items.allPage;
        var totalExists = $scope.items.pageExists;
        if(pageExists == 0){
            return false;
        }else{
            if(total <= totalExists){
                return false;
            }else{
                return true;
            }
        }
    };
    $scope.loadMoreData = function(){
        var PageExists  = document.getElementById('pageExists').value;
        var IdExists    = document.getElementById('idExists').value;
        dataService.postMore(_lang, $stateParams.postId, PageExists, IdExists).success(function(data) {
            if(data.success == true){
                for(i=0;i<data.content.length;i++){
                    var _id         = data.content[i].id;
                    var _prefix     = data.content[i].prefix;
                    var _title      = data.content[i].title;
                    var _thumb      = data.content[i].thumb;
                    var _preview    = data.content[i].preview;
                    var _tanggalv1  = data.content[i].tanggal;
                    var _tanggalv2  = data.content[i].tanggalv2;
                    var _counter    = data.content[i].counter;
                    
                    $scope.items.home.push({
                        id: _id,
                        prefix: _prefix,
                        title: _title,
                        tanggal: _tanggalv1,
                        tanggalv2: _tanggalv2,
                        counter: _counter,
                        thumb: _thumb,
                        preview: _preview
                    });
                    document.getElementById('pageExists').value = data.pageExists;
                }
			          $scope.$broadcast('scroll.infiniteScrollComplete');
            }
        });
    };
    posts();
    $scope.$on('$viewContentLoaded', function(){
        //view loaded do some stuff.
        $location.replace(); //clear last history route
    });
})

.controller('DetailCtrl', function($scope, $stateParams, dataService, $sce, $ionicSlideBoxDelegate, $ionicPopover, $cordovaSocialSharing) {
    var _lang     = document.getElementById('lang').value;
    $scope.details = function() {
        dataService.detail(_lang, $stateParams.detailId).success(function(data) {
              $scope.prefix     = data.prefix;
              $scope.title      = data.title;
              $scope.add_name   = data.add_name;
              $scope.edit_name  = data.edit_name;
              $scope.kontrib    = data.kontrib_name;
              $scope.tanggal    = data.tanggal;
              $scope.title      = data.title;
              $scope.kategori   = data.kategori;  
              $scope.content    = data.content;
              $scope.linkage    = data.linkage;
              $scope.link_page  = data.link_page;
              $scope.thumb1     = data.thumb1;
              setTimeout(function() {
                  $ionicSlideBoxDelegate.slide(0);
                  $ionicSlideBoxDelegate.update();
                  $scope.$apply();
              });
              
          }).finally(function(){
              $scope.$broadcast('scroll.refreshComplate');
          });
    };
    $scope.details();
    
    $ionicPopover.fromTemplateUrl('templates/popover_detail.html', {
        scope: $scope
    }).then(function(popover){
        $scope.popover = popover;
    });
    $scope.openPopover = function($event) {
        $scope.popover.show($event);
    };
    $scope.share_artikel = function($event){
        var subject = 'NU Online';
        var message = $scope.title;
        var link    = $scope.link_page;
        var file    = $scope.thumb1;
        $cordovaSocialSharing
        .share(message, subject, file, link) // Share via native share sheet
        .then(function(result) {
        }, function(err) {
        });
        $scope.popover.hide();
    };
    $scope.nextSlide = function($no) {
        $ionicSlideBoxDelegate.slide($no);
    };
});
